//+------------------------------------------------------------------+
//|                                         alb - moving average.mq4 |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  Orange
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2

//
//
//
//
//

extern int    swingCount       = 5;
extern int    mode             = MODE_EMA;
extern int    price            = PRICE_CLOSE;
extern double speed            = 1.0;
extern bool   alertsOn         = false; // Turn alert on or off
extern bool   alertsOnCurrent  = true;  // Alerts on current (still opened) bar
extern bool   alertsMessage    = true;  // Alerts should show pop-up message
extern bool   alertsPushNotif  = false; // Alerts should send push notification
extern bool   alertsSound      = false; // Alerts should play a sound
extern bool   alertsEmail      = false; // Alerts should send email

//
//
//
//
//

double swingBuffer[];
double maBuffer[];
double maBufferda[];
double maBufferdb[];
double slope[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,maBuffer);
   SetIndexBuffer(1,maBufferda);
   SetIndexBuffer(2,maBufferdb);
   SetIndexBuffer(3,swingBuffer);
   SetIndexBuffer(4,slope);
      speed = MathMax(speed,0.000001);
   return(0);
}
int deinit()
{
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;
         
   //
   //
   //
   //
   //

   if (slope[limit]==-1) CleanPoint(limit,maBufferda,maBufferdb);
   for(i=limit; i>=0; i--)
   {
      int swing = 0;
         if (High[i]>High[i+1] && High[i+1]>High[i+2] && Low[i+2] < Low[i+3] && Low[i+3] < Low[i+4]) swing = -1;
         if (Low[i] < Low[i+1] && Low[i+1] < Low[i+2] && High[i+2]>High[i+3] && High[i+3]>High[i+4]) swing =  1;
      swingBuffer[i] = swing;
   
      //
      //
      //
      //
      //
      
      int k = i;
      int n = 0;
         for (; (k<Bars) && (n<swingCount); k++) if(swingBuffer[k]!=0) n++;
               double albPeriod = MathMax(MathRound((k-i)/swingCount/speed),1);
      maBuffer[i]   = iMA(NULL,0,albPeriod,0,mode,price,i);
      maBufferda[i] = EMPTY_VALUE;
      maBufferdb[i] = EMPTY_VALUE;
      slope[i]      = slope[i+1];
         if (maBuffer[i]>maBuffer[i+1]) slope[i] =  1;
         if (maBuffer[i]<maBuffer[i+1]) slope[i] = -1;
         if (slope[i]==-1) PlotPoint(i,maBufferda,maBufferdb,maBuffer);
   }
   manageAlerts();
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>Bars-3) return;
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (slope[whichBar] != slope[whichBar+1])
      {
         if (slope[whichBar+1]==-1) doAlert(whichBar,"slope up");
         if (slope[whichBar+1]== 1) doAlert(whichBar,"slope down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message = Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" alb ma changed "+doWhat;
          if (alertsMessage)   Alert(message);
          if (alertsEmail)     SendMail(StringConcatenate(Symbol()," alb ma "),message);
          if (alertsPushNotif) SendNotification(StringConcatenate(Symbol()," alb ma "+message));
          if (alertsSound)     PlaySound("alert2.wav");
   }
}